<template>
	<div
		:id="id"
		:class="$style.block"
		class="u-wrap"
		:style="{ 'margin-right': reportsMarginRight, 'margin-left': reportsMarginLeft }"
	>
		<div :class="$style.row">
			<div :class="$style.col">
				<div :class="$style.contentBox">
					<div :class="$style.contentWrapper">
						<div v-rich-content :class="$style.content" v-html="content"></div>
					</div>
				</div>
			</div>
			<div :class="$style.col">
				<div>
					<ul :class="$style.papers">
						<li v-for="(file, index) in files" :key="index" :class="$style.paper">
							<article :class="$style.paperArticle">
								<a
									:href="(file.file && file.file.url) || '#'"
									target="_blank"
									:class="$style.paperLink"
									@click="track(file.file && file.file.url, 'view')"
								>
									<h3 :class="$style.paperHeading">{{ file.title1 }}</h3>
								</a>
								<p :class="$style.paperText"
									>{{ file.description }}
									<a
										v-if="file.file && file.file.url"
										:href="(file.file && file.file.url) || '#'"
										target="_blank"
										:class="$style.paperTextLink"
										@click="track(file.file && file.file.url, 'download')"
										>Download</a
									>
								</p>
							</article>
						</li>
					</ul>
					<div v-if="ctaLink && ctaLink.url && ctaText" :class="$style.buttonWrapper">
						<BaseButtonAuto
							:smart="ctaLink.url"
							:target="ctaLink.target"
							:appearance="ctaVariant"
							size="medium"
							force-color
						>
							{{ ctaText || ctaLink.url }}
						</BaseButtonAuto>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
export default {
	props: {
		id: {
			type: String,
			default: null,
		},

		content: {
			type: String,
			default: '',
		},

		ctaText: {
			type: String,
			default: '',
		},

		ctaLink: {
			type: Object,
			default: null,
		},

		files: {
			type: Array,
			default: () => [],
		},

		reportsMarginLeft: {
			type: String,
			default: 'auto',
		},

		reportsMarginRight: {
			type: String,
			default: 'auto',
		},

		ctaVariant: {
			type: String,
			default: 'primary',
		},
	},

	methods: {
		track(url, type) {
			const isDownload = type === 'download';
			this.$tealiumEvent(`whitepaper_${type}`, {
				event_category: isDownload ? 'Download Papers' : 'White Papers',
				event_action: `${isDownload ? 'Downloaded' : 'Viewed'} White Paper`,
				event_label: url,
				click_url: url,
			});
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.row {
	@include above('large') {
		display: flex;
	}
}

.block {
	margin-top: size('xxl');
	margin-bottom: size('xxl');
}

.col {
	display: flex;
	flex: 0 0 auto;

	&:first-child {
		margin-bottom: size('m');

		@include above('large') {
			width: 45%;
			margin-bottom: 0;
		}

		@include above('xlarge') {
			width: 50%;
		}
	}

	&:last-child {
		@include above('large') {
			justify-content: center;
			width: 55%;
		}

		@include above('xlarge') {
			width: 50%;
		}
	}
}

.contentBox {
	flex: 0 0 auto;
	width: 100%;
	padding: size('m') size('s');
	background-color: color('secondary-200');

	@include above('large') {
		display: flex;
		align-items: center;
		justify-content: center;
		max-width: 60rem;
	}
}

.contentWrapper {
	@include above('xlarge') {
		width: 45.6rem;
	}
}

.content {
	h2 {
		@include use-text-style('heading-700');
		@include font-family('secondary');

		width: 100%;
		margin-bottom: size('m');
		text-align: center;

		@include above('large') {
			text-align: left;
		}
	}

	p {
		color: color('primary-100');

		@include use-text-style('type');
		@include use-text-style('type-100');

		@include above('xlarge') {
			width: 43rem;
		}

		&:not(:last-child) {
			margin-bottom: size('s');
		}
	}
}

.papers {
	flex: 0 0 auto;
	width: 100%;
	list-style: none;

	@include above('large') {
		max-width: 50rem + size('s') * 2;
		padding: 0 size('s');
	}
}

.paperArticle {
	padding: size('xxs') size('s');
	border-bottom: 1px solid color('border');

	@include above('large') {
		padding: size('xxs') 0;
	}

	.paper:last-child & {
		@include above('large') {
			border-bottom: 0;
		}
	}
}

.paperHeading {
	@include use-text-style('heading-150');
	@include font-family('secondary');

	margin-bottom: size('base');
	font-weight: 300;
}

.paperText {
	color: color('primary-100');

	@include use-text-style('type');
	@include use-text-style('type-100');
}

.paperTextLink {
	font-weight: 700;
	color: color('text');
}

.buttonWrapper {
	margin-top: size('m');
	text-align: center;

	@include above('large') {
		padding-left: size('s');
		margin-top: size('xxs');
		text-align: left;
	}
}
</style>
